Index: BasicCompiler64/Compile_Object.cpp
===================================================================
--- BasicCompiler64/Compile_Object.cpp	(revision 73)
+++ BasicCompiler64/Compile_Object.cpp	(revision 75)
@@ -2,5 +2,5 @@
 #include "opcode.h"
 
-void _call_constructor(CClass *pobj_c,const char *CreateParameter,int ObjectSize,BOOL bSomeObjects){
+void _call_constructor( const CClass *pobj_c,const char *CreateParameter,int ObjectSize,BOOL bSomeObjects){
 	////////////////////////////
 	// コンストラクタの呼び出し
@@ -32,19 +32,19 @@
 	////////////////////////
 
-	std::vector<SubInfo *> subs;
+	std::vector<UserProc *> subs;
 	pobj_c->EnumMethod( pobj_c->name, subs );
 
-	SubInfo *psi;
+	UserProc *pUserProc;
 	if( subs.size() > 0 ){
 		//オーバーロードを解決
-		psi=OverloadSolutionWithStrParam(pobj_c->name,
-			subs,CreateParameter,"",NULL);
-
-		if(!psi) return;
+		pUserProc=OverloadSolutionWithStrParam(pobj_c->name,
+			subs,CreateParameter,"");
+
+		if(!pUserProc) return;
 	}
 
 	//コンストラクタを呼び出す
 	Opcode_CallProc(CreateParameter,
-		psi,
+		pUserProc,
 		PROCFLAG_NEW,"",0);
 
@@ -73,5 +73,5 @@
 	}
 }
-void Operator_New( CClass &classObj, const char *objectSizeStr, const char *parameter, const TYPEINFO &baseTypeInfo ){
+void Operator_New( const CClass &classObj, const char *objectSizeStr, const char *parameter, const Type &baseType ){
 	int typeSize = classObj.GetSize();
 
@@ -86,6 +86,7 @@
 
 		int reg=REG_RAX;
-		int type = NumOpe(&reg,objectSizeStr,0,0,0);
-		if(!IsWholeNumberType(type)) SetError(49,NULL,cp);
+		Type tempType;
+		NumOpe(&reg,objectSizeStr,Type(),tempType);
+		if( !tempType.IsWhole() ) SetError(49,NULL,cp);
 
 		//※添え字上限値であることを考慮
@@ -117,16 +118,18 @@
 	}
 
-	if( baseTypeInfo.type == DEF_OBJECT ){
-		//DeleteはGCで処理
+	if( baseType.IsObject() ){
+		// オブジェクト インスタンス
+		// ※DeleteはGCで処理
 
 		//call _System_GC_malloc_ForObject
-		extern SubInfo *pSub_System_GC_malloc_ForObject;
+		extern UserProc *pSub_System_GC_malloc_ForObject;
 		op_call(pSub_System_GC_malloc_ForObject);
 	}
 	else{
-		//明示的なDeleteが必要
+		// オブジェクトポインタ
+		// ※明示的なDeleteが必要
 
 		//call _System_GC_malloc_ForObjectPtr
-		extern SubInfo *pSub_System_GC_malloc_ForObjectPtr;
+		extern UserProc *pSub_System_GC_malloc_ForObjectPtr;
 		op_call(pSub_System_GC_malloc_ForObjectPtr);
 	}
@@ -162,6 +165,6 @@
 	op_mov_RV(sizeof(_int64),REG_RCX,0);
 	obp-=sizeof(long);
-	pobj_SubAddrSchedule->add(method->psi,0);
-	method->psi->bUse=1;
+	pobj_SubAddrSchedule->add(method->pUserProc,0);
+	method->pUserProc->Using();
 	obp+=sizeof(long);
 
@@ -190,73 +193,11 @@
 	pobj_sf->pop(REG_RAX);
 }
-int Operator_New(const char *Parameter,LONG_PTR *plpIndex,const TYPEINFO &baseTypeInfo ){
-	char TypeName[VN_SIZE],CreateParameter[VN_SIZE],objectSizeStr[VN_SIZE];
-	int i,i2;
-
-	i=0;
-
-	if(Parameter[0]=='['){
-		i=GetStringInBracket(objectSizeStr,Parameter);
-
-		SlideString(objectSizeStr+1,-1);
-		objectSizeStr[i-2]=0;
-	}
-	else objectSizeStr[0]=0;
-
-	for(i2=0;;i++,i2++){
-		if(Parameter[i]=='('){
-			TypeName[i2]=0;
-
-			//コンストラクタに渡すパラメータを取得
-			i2=GetStringInPare(CreateParameter,Parameter+i);
-			RemoveStringPare(CreateParameter);
-			i+=i2;
-			if(Parameter[i]!='\0'){
-				SetError(42,NULL,cp);
-				return 0;
-			}
-			break;
-		}
-		TypeName[i2]=Parameter[i];
-		if(Parameter[i]=='\0'){
-			CreateParameter[0]=0;
-			break;
-		}
-	}
-
-	int type;
-	type=GetTypeFixed(TypeName,plpIndex);
-	if(type==-1){
-		SetError(3,TypeName,cp);
-		return 0;
-	}
-
-	if(type!=DEF_OBJECT){
-		////////////////////////
-		// 通常のデータ型の場合
-		////////////////////////
-
-		SetError(121,NULL,cp);
-		return 0;
-	}
-
-	CClass *pobj_c;
-	pobj_c=(CClass *)*plpIndex;
-
-	Operator_New( *pobj_c, objectSizeStr, CreateParameter, baseTypeInfo );
-
-	if( baseTypeInfo.type == DEF_OBJECT ){
-		return DEF_OBJECT;
-	}
-	return DEF_PTR_OBJECT;
-}
-
 void OpcodeDelete(const char *Parameter, bool isSweeping){
-	int type;
-
 	int reg=REG_RAX;
-	type=NumOpe(&reg,Parameter,0,0,0);
-	if(type==-1) return;
-	if(!(type==DEF_PTR_OBJECT||type==DEF_PTR_VOID)) SetError(122,NULL,cp);
+	Type tempType;
+	if( !NumOpe(&reg,Parameter,Type(),tempType) ){
+		return;
+	}
+	if(!( tempType.IsObjectPtr() || tempType.IsVoidPtr() )) SetError(122,NULL,cp);
 
 	//sub rax,PTR_SIZE*3
@@ -328,10 +269,10 @@
 	if( isSweeping ){
 		//call _System_GC_free_for_SweepingDelete
-		extern SubInfo *pSub_System_GC_free_for_SweepingDelete;
+		extern UserProc *pSub_System_GC_free_for_SweepingDelete;
 		op_call(pSub_System_GC_free_for_SweepingDelete);
 	}
 	else{
 		//call free
-		extern SubInfo *pSub_free;
+		extern UserProc *pSub_free;
 		op_call(pSub_free);
 	}
